#include <Wire.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27,16,2);  //Set the LCD address to 0x27 for a 16 chars and 2 line display

int val = 0;       // variable to store the value coming from the sensor

int button01Pin = 3;
int button01State = 0;

int button02Pin = 4;
int button02State = 0;
int funcNum = 1;

//Ultrasonic Sensor
int trigPin = 9;
int echoPin = 10;
int ledPin = 13;
//int ledPinRed = 11;
//int ledPinGrn = 12;

const int speakerPin = 7;

//Motion Sensor
int sensor = 2;
//int motionState = LOW;
int valMotion = 0;
int i = 0;

int keyUltra = 0;
int keyUltra02 = 0;
int keyUltra03 = 0;
int windowKey = 0;
int zoomKey = 0;
int keyMotion = 0;

float duration, distance;
long inches, cm;



void setup() {
  Serial.begin(9600);
  lcdStart();
  
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  pinMode(ledPin, OUTPUT);  // declare the ledPin as an OUTPUT
  pinMode(sensor, INPUT);

  //pinMode(ledPinRed, OUTPUT);
  //pinMode(ledPinGrn, OUTPUT);

  pinMode(button01Pin, INPUT);
  pinMode(button02Pin, INPUT);
}



void loop() {
  buttonForReset();
  motionDetector();

  buttonForChangeFunc();

  if (funcNum == 1) {
    lcdDistance01Default();
    distanceDetector01();
  }
  else if (funcNum == 2){
    lcdDistance02Default();
    distanceDetector02();
  }
  else if (funcNum == 3){
    lcdDistance03Default();
    distanceDetector03();
  }
}



long microsecondsToCentimeters(long microseconds) {
   return microseconds / 29 / 2;
}



void lcdStart() {
  lcd.init();           // initialize the lcd 
  lcd.init();           // Print a message to the LCD.
  lcd.backlight();
  lcd.setCursor(0,0);
  lcd.print("GESTURE CONTROL");
  delay(1000);
  lcd.setCursor(4,1);
  lcd.print("COMPUTER");
  delay(3000);
  lcd.clear();
  lcd.setCursor(2,0);
  lcd.print("DESIGNED BY");
  delay(1000);
  lcd.setCursor(4,1);
  lcd.print("JAY HUH");
  delay(3000);
  lcd.clear();
}



void lcdDistance01Default() {
  lcd.setCursor(0,0);
  lcd.print("POSTURE 1: ");
  lcd.setCursor(0,1);
  lcd.print("ATTENTION: ");
}

void lcdDistance01Far() {
  //lcd.clear();
  //lcd.setCursor(0,0);
  //lcd.print("MODE 1: WINDOWS");
  lcd.setCursor(11,0);
  lcd.print("FAR  ");
}

void lcdDistance01Close() {
  //lcd.clear();
  //lcd.setCursor(0,0);
  //lcd.print("MODE 1: WINDOWS");
  lcd.setCursor(11,0);
  lcd.print("CLOSE");
}



void lcdDistance02Default() {
  lcd.setCursor(0,0);
  lcd.print("POSTURE 2: ");
  lcd.setCursor(0,1);
  lcd.print("ATTENTION: ");
}

void lcdDistance02Far() {
  lcd.setCursor(11,0);
  lcd.print("FAR  ");
}

void lcdDistance02Close() {
  lcd.setCursor(11,0);
  lcd.print("CLOSE");
}



void lcdDistance03Default() {
  lcd.setCursor(0,0);
  lcd.print("POSTURE 3: ");
  lcd.setCursor(0,1);
  lcd.print("ATTENTION: ");
}

void lcdDistance03Far() {
  lcd.setCursor(11,0);
  lcd.print("FAR  ");
}

void lcdDistance03Close() {
  lcd.setCursor(11,0);
  lcd.print("CLOSE");
}


void lcdMotionStop() {
  lcd.setCursor(11,1);
  lcd.print("HIGH ");
}

void lcdMotionMove() {
  lcd.setCursor(11,1);
  lcd.print("LOW  ");
}



int buttonForChangeFunc() {
  button02State = digitalRead(button02Pin);
  
  if (button02State == HIGH) {
    lcd.clear();
    
    tone(speakerPin, 500, 500);
    delay(10);
    //tone(speakerPin, 1000, 500);
    //delay(10);
    //  tone(speakerPin, 1500, 500);
    //  delay(1000);
    //  tone(speakerPin, 2000, 500);
    //  delay(1000);
   
    if (funcNum < 3) {
      digitalWrite(ledPin, HIGH);
      funcNum++; 
    }
    else {
      funcNum = 1;
    }
    Serial.print("-----Function: ");
    Serial.print(funcNum);
    Serial.println("-----"); 
  } 
  else {
    digitalWrite(ledPin, LOW);
  }

  return funcNum;
}



void buttonForReset() {
  button01State = digitalRead(button01Pin);
  
  if (button01State == HIGH) {
    digitalWrite(ledPin, HIGH);
    keyMotion = 0;
    //keyUltra = 0;
    Serial.println("-----RESET-----");
  } 
  else {
    digitalWrite(ledPin, LOW);
  }
}



void motionDetector() {
  valMotion = digitalRead(sensor);
  
  if (valMotion == HIGH && keyMotion == 0) {
    if (i == 6) {
      //if (motionState == LOW) {
        Serial.println("Motion Detector: Detected");
        lcdMotionMove();
        //motionState = HIGH;
        i = 0;
        keyMotion = 1;
      //}
    }
    else {
      i++;
      Serial.print("Motion Detector: ");
      Serial.println(i);
      //delay(200);
    }
  }
  else if (valMotion == HIGH && keyMotion == 1) {
    Serial.println("Motion Detector: Need reset");
    lcdMotionMove();
  }
  else {
    //if(motionState == HIGH) {
      Serial.println("Motion Detector: Stopped");
      lcdMotionStop();
      //motionState = LOW;
      i = 0;
    //}
  }
  delay(1000);
}



void distanceDetector01() {
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);

  duration = pulseIn(echoPin, HIGH);
  //cm = microsecondsToCentimeters(duration);
  
  if (duration < 3000 && keyUltra == 1) {
    //digitalWrite(ledPinGrn, HIGH);
    //digitalWrite(ledPinRed, LOW);

    Serial.println("Distance Detector01: Close");
    lcdDistance01Close();
    keyUltra = 0;
  }
  else if (3000 <= duration && duration < 6000 && keyUltra == 0) {
    //digitalWrite(ledPinGrn, HIGH);
    //digitalWrite(ledPinRed, LOW);

    Serial.println("Distance Detector01: Far");
    lcdDistance01Far();
    keyUltra = 1;
  }
  else if (16000 <= duration && keyUltra == 0) {
    Serial.println("Distance Detector01: Error");
  }
  else if (16000 <= duration && keyUltra == 1) {
    Serial.println("Distance Detector01: Error");
  }
  else {    
    //digitalWrite(ledPinGrn, LOW);
    //digitalWrite(ledPinRed, HIGH);

    Serial.println("Distance Detector01: Nothing");
  }
}



void distanceDetector02() {
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);

  duration = pulseIn(echoPin, HIGH);
  //cm = microsecondsToCentimeters(duration);
  
  if (duration < 3000 && keyUltra02 == 1) {
    //digitalWrite(ledPinGrn, HIGH);
    //digitalWrite(ledPinRed, LOW);

    Serial.println("Distance Detector02: Video rewind");
    lcdDistance02Close();
    keyUltra02 = 0;
  }
  else if (3000 <= duration && duration < 6000 && keyUltra02 == 0) {    
    //digitalWrite(ledPinGrn, LOW);
    //digitalWrite(ledPinRed, HIGH);

    Serial.println("Distance Detector02: Nothing/Reset");
    lcdDistance02Far();
    keyUltra02 = 1;
  }
  else if (16000 <= duration && keyUltra02 == 0) {
    Serial.println("Distance Detector02: Error");
  }
  else if (16000 <= duration && keyUltra02 == 1) {
    Serial.println("Distance Detector02: Error");
  }
  else {    
    //digitalWrite(ledPinGrn, LOW);
    //digitalWrite(ledPinRed, HIGH);

    Serial.println("Distance Detector02: Nothing");
  }
}



void distanceDetector03() {
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);

  duration = pulseIn(echoPin, HIGH);
  
  if (duration < 3000 && keyUltra03 == 1) {
    Serial.println("Distance Detector03: Zoom in");
    lcdDistance03Close();
    keyUltra03 = 0;
    zoomKey = 1;
  }
  else if (3000 <= duration && duration < 6000 && keyUltra03 == 0) {    
    if (zoomKey == 0){
      Serial.println("Distance Detector03: Default");
    }
    else if (zoomKey == 1) {
      Serial.println("Distance Detector03: Zoom out");
      zoomKey = 0;
    }
    lcdDistance03Far();
    keyUltra03 = 1;
  }
  else if (16000 <= duration && keyUltra03 == 0) {
    Serial.println("Distance Detector03: Error");
  }
  else if (16000 <= duration && keyUltra03 == 1) {
    Serial.println("Distance Detector03: Error");
  }
  else {    
    Serial.println("Distance Detector03: Nothing");
  }
}
